<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formCompanyInfo"
      :model="formData"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormCompanyInfo()" @reset="resetFormCompanyInfo">
        <el-form-item label="公司名称">
          <el-input
            class="filter-item"
            v-model="formFilter.companyNameFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formCompanyInfoTable"
      class="page-table"
      :data="formCompanyInfoTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formCompanyInfoTableWidgetCurrentPage - 1) * formCompanyInfoTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formCompanyInfoTableWidget.onSortChange"
      @refresh="formCompanyInfoTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onAddCompanyInfoClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onExportCompanyInfoClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :on-change="onImportCompanyInfoClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formCompanyInfoTableWidget.getTableIndex" :width="80" />
      <vxe-column title="公司名称" field="companyName" />
      <vxe-column title="公司地址" field="address" />
      <vxe-column title="成立日期" field="establishDate">
        <template v-slot="scope">
          <span>{{formatDateByStatsType(scope.row.establishDate, 'day')}}</span>
        </template>
      </vxe-column>
      <vxe-column title="联系电话" field="telephone" />
      <vxe-column title="公司网站链接" field="website" />
      <vxe-column title="公司类型" field="companyTypeDictMap.name" />
      <vxe-column title="公司邮箱" field="email" />
      <vxe-column title="公司图片" min-width="100px">
        <template v-slot="scope">
          <el-image v-for="item in parseUploadData(scope.row.companyUrl, { id: scope.row.id, fieldName: 'companyUrl', asImage: true })"
            :preview-src-list="getPictureList(scope.row.companyUrl, { id: scope.row.id, fieldName: 'companyUrl', asImage: true })"
            class="table-cell-image" :key="item.url" :src="item.url" fit="fill">
            <template #error>
              <div class="table-cell-image">
                <i class="el-icon-picture-outline"></i>
              </div>
            </template>
          </el-image>
        </template>
      </vxe-column>
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditCompanyInfoClick(scope.row)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteCompanyInfoClick(scope.row)"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formCompanyInfoTableWidgetTotalCount"
            :current-page="formCompanyInfoTableWidgetCurrentPage"
            :page-size="formCompanyInfoTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formCompanyInfoTableWidget.onCurrentPageChange"
            @size-change="formCompanyInfoTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formCompanyInfo',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { CompanyContentData } from '@/api/generated/companyContentController';
import { CompanyInfoData } from '@/api/generated/companyInfoController';
import { CompanyContentController, CompanyInfoController } from '@/api/generated';
import FormEditCompanyInfo from '@/pages/CompanyInfo/formEditCompanyInfo.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 公司名称
  companyNameFilter: undefined,
});
const formFilterCopy = reactive({
  // 公司名称
  companyNameFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormCompanyInfo();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormCompanyInfoTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    companyInfoDtoFilter: {
      companyName: formFilter.companyNameFilter,
    }
  };
  return new Promise((resolve, reject) => {
    CompanyInfoController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormCompanyInfoTableVerify = () => {
  formFilterCopy.companyNameFilter = formFilter.companyNameFilter;
  return true;
};
/**
 * 新建
 */
const onAddCompanyInfoClick = (row?: CompanyInfoData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditCompanyInfo, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formCompanyInfoTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditCompanyInfoClick = (row?: CompanyInfoData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditCompanyInfo, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formCompanyInfoTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportCompanyInfoClick = (row?: CompanyInfoData) => {
  let params: ANY_OBJECT = {
  };

  CompanyInfoController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportCompanyInfoClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  CompanyInfoController.import(params).then(res => {
    ElMessage.success('导入成功');
    formCompanyInfoTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteCompanyInfoClick = (row?: CompanyInfoData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    CompanyInfoController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formCompanyInfoTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formCompanyInfoTableOptions: TableOptions<CompanyInfoData> = {
  loadTableData: loadFormCompanyInfoTableWidgetData,
  verifyTableParameter: loadFormCompanyInfoTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formCompanyInfoTable = ref();
const formCompanyInfoTableWidget = useTable(formCompanyInfoTableOptions);
const {
  dataList: formCompanyInfoTableWidgetDataList,
  currentPage: formCompanyInfoTableWidgetCurrentPage,
  pageSize: formCompanyInfoTableWidgetPageSize,
  totalCount: formCompanyInfoTableWidgetTotalCount,
} = formCompanyInfoTableWidget;
const refreshFormCompanyInfo = () => {
  // 刷新段落
  formCompanyInfoTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormCompanyInfo = () => {
  formFilter.companyNameFilter = undefined;
  formFilterCopy.companyNameFilter = undefined;
  refreshFormCompanyInfo();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormCompanyInfo();
};
const formInit = () => {
  refreshFormCompanyInfo();
};

onMounted(() => {
  formInit();
});
</script>